stages:
  - test
  - build
  - deploy

test_staging:
  image: node:14.15.3-alpine
  stage: test
  script:
    - yarn
    - CI=false yarn run build:staging
  only:
    - master
  except:
    - master@excel-mec/excel-accounts/Excel-Accounts-Frontend
test_prod:
  image: node:14.15.3-alpine
  stage: test
  script:
    - yarn
    - CI=false yarn run build:prod
  only:
    - prod
  except:
    - prod@excel-mec/excel-accounts/Excel-Accounts-Frontend

build_staging:
  image: node:14.15.3-alpine
  stage: build
  script:
    - yarn
    - CI=false yarn run build:staging
  artifacts:
    expire_in: 1 week
    paths:
      - build
  only:
    - master@excel-mec/excel-accounts/Excel-Accounts-Frontend
build_prod:
  image: node:14.15.3-alpine
  stage: build
  script:
    - yarn
    - CI=false yarn run build:prod
  artifacts:
    expire_in: 1 week
    paths:
      - build
  only:
    - prod@excel-mec/excel-accounts/Excel-Accounts-Frontend

deploy_staging:
  image: alpine
  stage: deploy
  script:
    - apk add --no-cache rsync openssh
    - mkdir -p ~/.ssh
    - echo "$DEVELOPMENT_SERVER_PRIVATE_KEY" >> ~/.ssh/id_dsa
    - chmod 600 ~/.ssh/id_dsa
    - echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config
    - rsync -rav --delete build/ $DEVELOPMENT_SERVER_USERNAME@$DEVELOPMENT_SERVER_IP:~/Excel-Accounts-Service/Excel-Accounts-Frontend/build
    - ssh $DEVELOPMENT_SERVER_USERNAME@$DEVELOPMENT_SERVER_IP docker-compose -f Excel-Accounts-Service/$DEVELOPMENT_DOCKER_COMPOSE_FILE restart
  only:
    - master@excel-mec/excel-accounts/Excel-Accounts-Frontend
deploy_prod:
  image: alpine
  stage: deploy
  script:
    - apk add --no-cache rsync openssh
    - mkdir -p ~/.ssh
    - echo "$PRODUCTION_SERVER_PRIVATE_KEY" >> ~/.ssh/id_dsa
    - chmod 600 ~/.ssh/id_dsa
    - echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config
    - rsync -rav --delete build/ $PRODUCTION_SERVER_USERNAME@$PRODUCTION_SERVER_IP:~/Excel-Accounts-Service/Excel-Accounts-Frontend/build
    - ssh $PRODUCTION_SERVER_USERNAME@$PRODUCTION_SERVER_IP docker-compose -f Excel-Accounts-Service/$PRODUCTION_DOCKER_COMPOSE_FILE restart
  only:
    - prod@excel-mec/excel-accounts/Excel-Accounts-Frontend
